// Set of symbolic markings -*- c++ -*-

#pragma implementation
#include "ExpressionMSet.h"
#include "Marking.h"
#include "Constant.h"
#include "CardType.h"
#include "LeafValue.h"
#include "Net.h"

/** @file ExpressionMSet.C
 * Multi-set of expressions (transient storage for quantification)
 */

class Marking*
ExpressionMSet::toMarking (const class Place* place)
{
  class Marking* m = NULL;
  for (iterator i = begin (); i != end (); i++) {
    assert (i->second > 0);
    class Expression* mult = i->second != 1
      ? new class Constant (*new class LeafValue
			    (Net::getCardType (), i->second))
      : NULL;
    class Expression* expr = i->first;
    class Marking* mm;
    if (expr->getKind () == Expression::eMarking) {
      mm = static_cast<class Marking*>(expr);
      assert (mm->getPlace () == place);
      if (mm->getNext () || (mult && mm->getMultiplicity ()))
	(mm = new class Marking (place, mm))->setMultiplicity (mult);
      else if (mult)
	mm->setMultiplicity (mult);
    }
    else {
      mm = new class Marking (place);
      mm->setToken (expr);
      mm->setMultiplicity (mult);
    }
    if (m)
      m->append (*mm);
    else
      m = mm;
  }
  return m;
}
